<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    target: {
      type: String,
      required: true,
      default: null,
    },
  },
  methods: {
    async copy(codeSnippet: string) {
      const sanitizedCodeSnippet = codeSnippet
        .replace(/`/g, '')
        .split('\n')
        .filter((line) => line.trim() !== '')
        .join('\n');
      await navigator.clipboard.writeText(sanitizedCodeSnippet);
    },
  },
});
</script>

<template>
  <span>
    <button
      class="copy-button"
      type="button"
      aria-label="Copy code snippet to clipboard"
      @click="copy(target)"
    >
      <SlpIcon name="copy-to-clipboard" variant="product" />
    </button>
  </span>
</template>

<style scoped lang="scss">
.copy-button {
  border: none;
  cursor: pointer;
  box-shadow: none;

  &:active {
    box-shadow:
      0 0 0 1px #333,
      0 0 0 3px #1f75cb;
  }
}
</style>
